/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: nserv.c,v 1.0 2003/06/20 08:00:41 abe Exp abe $
 */

/* 
 *  лץ
 */

#include <s_services.h>
#include <t_services.h>
#include "kernel_id.h"
#include "tinet_id.h"

#include <tinet_config.h>

#include <net/net_var.h>

#include "nserv.h"

/*
 *  TCP Хåե
 */

UB tcp_echo_cli_cep_sbuf[TCP_ECHO_CLI_CEP_SBUF_SIZE];
UB tcp_echo_cli_cep_rbuf[TCP_ECHO_CLI_CEP_RBUF_SIZE];

UB tcp_discard_cli_cep_sbuf[TCP_DISCARD_CLI_CEP_SBUF_SIZE];
UB tcp_discard_cli_cep_rbuf[TCP_DISCARD_CLI_CEP_RBUF_SIZE];

UB tcp_echo_srv_cep_sbuf[NUM_TCP_ECHO_SRV_TASKS][TCP_ECHO_SRV_CEP_SBUF_SIZE];
UB tcp_echo_srv_cep_rbuf[NUM_TCP_ECHO_SRV_TASKS][TCP_ECHO_SRV_CEP_RBUF_SIZE];

UB tcp_discard_srv_cep_sbuf[TCP_DISCARD_SRV_CEP_SBUF_SIZE];
UB tcp_discard_srv_cep_rbuf[TCP_DISCARD_SRV_CEP_RBUF_SIZE];

UB www_srv_cep_sbuf[NUM_WWW_SRV_TASKS][WWW_SRV_CEP_SBUF_SIZE];
UB www_srv_cep_rbuf[NUM_WWW_SRV_TASKS][WWW_SRV_CEP_RBUF_SIZE];

#ifdef ARP_CFG_CALLBACK_DUPLICATED

BOOL arp_callback_duplicated (UB *shost)
{
	static UB shost_addr[sizeof("00:00:00:00:00:00")];

	mac2str(shost_addr, shost);
	syslog(LOG_ERROR, "[NSERV] IP address duplicated: %s", shost_addr);

	return FALSE;
	}

#endif	/* of #ifdef ARP_CFG_CALLBACK_DUPLICATED */
