/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: echo.h,v 1.2.1.3 2005/07/25 08:05:12 abe Exp abe $
 */

#ifndef _ECHO_H_
#define _ECHO_H_

/* 
 *  ECHO 饤ȡ
 */

#define TCP_ECHO_SRV_STACK_SIZE		1024		/* TCP ECHO ХΥå		*/
#define TCP_ECHO_CLI_RCV_STACK_SIZE	1024		/* TCP ECHO 饤ȼΥå	*/
#define TCP_ECHO_CLI_SND_STACK_SIZE	1024		/* TCP ECHO 饤Υå	*/

#define UDP_ECHO_SRV_STACK_SIZE		1024		/* UDP ECHO ХΥå		*/
#define UDP_ECHO_CLI_STACK_SIZE		1024		/* UDP ECHO 饤ȥΥå	*/

#define TCP_ECHO_SRV_MAIN_PRIORITY	5		/* TCP ECHO Хͥ			*/
#define TCP_ECHO_CLI_RCV_MAIN_PRIORITY	5		/* TCP ECHO 饤ȼͥ		*/
#define TCP_ECHO_CLI_SND_MAIN_PRIORITY	5		/* TCP ECHO 饤ͥ		*/

#define UDP_ECHO_SRV_MAIN_PRIORITY	5		/* UDP ECHO Хͥ			*/
#define UDP_ECHO_CLI_MAIN_PRIORITY	5		/* UDP ECHO 饤ȥͥ		*/

/* ECHO 塼 */

#define NUM_DTQ_UDP_ECHO_CLI	2	/* UDP ECHO 塼	*/
#define NUM_DTQ_TCP_ECHO_CLI	2	/* TCP ECHO 塼	*/

/*
 *  ѿ
 */

extern BOOL	tcp_echo_cli_valid;

/*
 *  
 */

extern void	tcp_echo_srv_task(VP_INT exinf);
extern void	tcp_echo_srv_rcv_task(VP_INT exinf);
extern void	tcp_echo_srv_snd_task(VP_INT exinf);
extern void	tcp_echo_cli_rcv_task(VP_INT exinf);
extern void	tcp_echo_cli_snd_task(VP_INT exinf);

extern void	udp_echo_srv_task(VP_INT exinf);
extern void	udp_echo_cli_task(VP_INT exinf);

/*
 *  ؿ
 */

extern ER callback_nblk_tcp_echo_srv (ID cepid, FN fncd, VP p_parblk);
extern ER callback_nblk_tcp_echo_cli (ID cepid, FN fncd, VP p_parblk);

extern ER callback_udp_echo_srv (ID cepid, FN fncd, VP p_parblk);
extern ER callback_udp_echo_cli (ID cepid, FN fncd, VP p_parblk);

extern ER callback_nblk_udp_echo_srv (ID cepid, FN fncd, VP p_parblk);
extern ER callback_nblk_udp_echo_cli (ID cepid, FN fncd, VP p_parblk);

#endif	/* of #ifndef _ECHO_H_ */
