/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: ip6.h,v 1.2.1.3 2005/07/25 08:06:42 abe Exp abe $
 */

/*	$FreeBSD: src/sys/netinet/ip6.h,v 1.2.2.2 2001/07/03 11:01:46 ume Exp $	*/
/*	$KAME: ip6.h,v 1.18 2001/03/29 05:34:30 itojun Exp $	*/

/*
 * Copyright (C) 1995, 1996, 1997, and 1998 WIDE Project.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the project nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE PROJECT AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE PROJECT OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * Copyright (c) 1982, 1986, 1993
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	@(#)ip.h	8.1 (Berkeley) 6/10/93
 */
 
#ifndef _IP6_H_
#define _IP6_H_

#ifdef SUPPORT_INET6

/*
 *  IPv6 RFC2460 
 */

#define IPV6_VERSION	6

/*
 *  IPv6 إå
 */

typedef struct t_ip6_hdr {
	UW vcf;		/* Version:        4 bit		*/
			/* Traffic Class:  8 bit		*/
			/* Flow Label:    20 bit		*/
	UH plen;	/* Payload Length			*/
	UB next;	/* Next Header				*/
	UB hlim;	/* Hop Limit				*/
	T_IN6_ADDR src;	/* Source Address			*/
	T_IN6_ADDR dst;	/* Destination Address			*/
	} T_IP6_HDR;

#define IP6_HDR_SIZE		(sizeof(T_IP6_HDR))

/*
 *  IPv6 إå¤ΥХޥ
 */

#define IP6_MAKE_VCF(v,cf)	(((v)<<28)|(cf))
#define IP6_VCF_V(vcf)		((vcf)>>28)
#define IP6_VCF_C(vcf)		(((vcf)>>20)&0xff)
#define IP6_VCF_F(vcf)		((vcf)&0x000fffff)
#define IP6_VCF_CF(vcf)		((vcf)&0x0fffffff)

/*
 *  ĥإå
 */

/*
 *  ĥإå
 */

typedef struct t_ip6_ext_hdr {
	UB next;	/* Next Header			*/
	UB len;		/* 8 ƥåñ̤Ĺ	*/
	} T_IP6_EXT_HDR;

/*
 *   (Hop-by-Hop) ץإå
 */

typedef struct t_ip6_hbh_hdr {
	UB next;	/* Next Header			*/
	UB len;		/* 8 ƥåñ̤Ĺ
			 * ΥץإåΤΥƥåȿ
			 * 8 ǳäͤ - 1 롣
			 */
	} T_IP6_HBH_HDR;

/*
 *   (Destination) ץإå
 */

typedef struct t_ip6_dest_hdr {
	UB next;	/* Next Header			*/
	UB len;		/* 8 ƥåñ̤Ĺ
			 * ΥץإåΤΥƥåȿ
			 * 8 ǳäͤ - 1 롣
			 */
	} T_IP6_DEST_HDR;

/*  (Hop-by-Hop) ץ */

#define IP6OPT_PAD1		0x00	/* 00 0 00000 */
#define IP6OPT_PADN		0x01	/* 00 0 00001 */
#define IP6OPT_JUMBO		0xc2	/* 11 0 00010 */
#define IP6OPT_NSAP_ADDR	0xc3	/* 11 0 00011 */
#define IP6OPT_TUNNEL_LIMIT	0x04	/* 00 0 00100 */
#define IP6OPT_RTR_ALERT	0x05	/* 00 0 00101 */

#define IP6OPT_MINLEN		2	/* ץκûĹ		*/

/* ̤ΤΥץνλ */

#define IP6OPT_TYPE_SKIP	0x00	/* ̵뤹롣			*/
#define IP6OPT_TYPE_DISCARD	0x40	/* ǡ˴롣	*/
#define IP6OPT_TYPE_FORCEICMP	0x80	/* ˴ơICMP 롣	*/
#define IP6OPT_TYPE_ICMP	0xc0
		/* ˴ơޥ㥹ȤǤʤ ICMP 롣	*/

#define IP6OPT_TYPE(o)		((o)&0xc0)

/*
 *  ϩإå
 */

typedef struct t_ip6_rt_hdr {
	UB next;	/* Next Header			*/
	UB len;		/* 8 ƥåñ̤Ĺ
			 * ΥץإåΤΥƥåȿ
			 * 8 ǳäͤ - 1 롣
			 */
	UB type;	/* ϩ楿		*/
	UB segleft;	/* ȤλĤ		*/
	} T_IP6_RT_HDR;

/*
 *  ʬإå
 */

typedef struct t_ip6_frag_hdr {
	UB next;	/* Next Header			*/
	UB reserved;
	UH off_flag;	/* եåȤȥե饰		*/
	UW ident;	/* ʬ伱̻			*/
	} T_IP6_FRAG_HDR;

/* ʬإåΥեåȤȥե饰 */

#if SIL_ENDIAN == SIL_ENDIAN_BIG

#define IP6F_OFF_MASK		0xfff8		/* եåȤФޥ	*/
#define IP6F_RESERVED_MASK	0x0006		/* ͽФޥ		*/
#define IP6F_MORE_FRAG		0x0001		/* ֥ե饰		*/

#elif SIL_ENDIAN == SIL_ENDIAN_LITTLE

#define IP6F_OFF_MASK		0xf8ff		/* եåȤФޥ	*/
#define IP6F_RESERVED_MASK	0x0600		/* ͽФޥ		*/
#define IP6F_MORE_FRAG		0x0100		/* ֥ե饰		*/

#endif	/* #if SIL_ENDIAN == SIL_ENDIAN_BIG */

/*
 *  
 */

#define IPV6_MAXHLIM	255	/* ۥåץߥåȤκ				*/
#define IPV6_DEFHLIM	64	/* ۥåץߥåȤε				*/
#define IPV6_MMTU	1280	/* Ǿ MTUڥ (1024) + إå (256)	*/
#define IPV6_MAXPACKET	65535	/* ܥڥɤѥåȥ	*/

/*
 *  IPv4  IPv6 򥳥ѥ򤹤뤿Υޥ
 */

/*
 *  ۥåץߥåȤεͤϡ롼Τˤѹ뤳Ȥ
 */

#if NUM_ND6_DEF_RTR_ENTRY > 0

/* 롼ΤϡΤ줿 */

#define IP_DEFTTL	ip6_defhlim

#else	/* #if NUM_ND6_DEF_RTR_ENTRY > 0 */

/* 롼Τʤͤϴ */

#define IP_DEFTTL	IPV6_DEFHLIM

#endif	/* #if NUM_ND6_DEF_RTR_ENTRY > 0 */

#define IP_HDR_SIZE	IP6_HDR_SIZE
#define T_IP_HDR	T_IP6_HDR

#endif	/* of #ifdef SUPPORT_INET6 */

#endif	/* of #ifndef _IP6_H_ */
